/*	cold.c

	Cold start for PAPERS.

	1995 by Hank Dietz
*/


#include <stdio.h>
#include "papers.c"


#define	P_MODE(x) \
	outb(((unsigned char)(x)), ((unsigned short) P_PORTBASE+2))
#define	P_NAK	0x01		/* Not interrupt ack */
#define	P_IRQ	0x02		/* Interrupt request */
#define	P_SEL	0x04		/* Int/Rdy Select */
				/* 0x08 isn't used */

#ifdef	P_VAPERS


main()
{
	/* Check-in with the simulator... */
	p_init();

	P_MODE(P_NAK);
	P_MODE(P_NAK);

	fprintf(stderr,
		"Cold-starting PAPERS PE%d connection....\n\n",
		IPROC);

	fprintf(stderr,
		"The PE%d LED should be dark now.\n",
		IPROC);

	/* Now exit cleanly... */
	p_exit(0);
	exit(0);
}


#else	/* ifndef P_VAPERS */


main()
{
	/* Only initialize environment, don't p_init() */
	p_initenv();

	/* Get port access... */
	if (ioperm(P_PORTBASE, 3, 1)) {
		fprintf(stderr,
			"%s: port access refused (need to be priv)\n");
		exit(2);
	}

	P_MODE(P_NAK);
	P_MODE(P_NAK);

	fprintf(stderr,
		"Cold-starting PAPERS PE%d connection....\n\n",
		IPROC);

	fprintf(stderr,
		"The PE%d LED should be dark now.\n",
		IPROC);

	/* Now exit cleanly... */
	p_exit(0);
	exit(0);
}


#endif
