#ifndef _GATHER_H
#define _GATHER_H


#include "types.h"


/*	Basic object gather operations... */
#define	XGATHER(name, type, bitcnt) \
extern void \
name(register type *dest, \
register type datum);

XGATHER(p_gather1u,  uint1,  1)
XGATHER(p_gather8,    int8,  8)
XGATHER(p_gather8u,  uint8,  8)
XGATHER(p_gather16,   int16, 16)
XGATHER(p_gather16u, uint16, 16)
XGATHER(p_gather32,   int32, 32)
XGATHER(p_gather32u, uint32, 32)
XGATHER(p_gather64,   int64, 64)
XGATHER(p_gather64u, uint64, 64)
XGATHER(p_gatherf,      f32, 32)
XGATHER(p_gatherd,      f64, 64)

#undef	XGATHER


/*	Bit sequence gather operations...
*/
#define	XGATHERBITS(name, type) \
extern void \
name(register type *dest, \
register type datum, \
register int bits);

XGATHERBITS(p_gatherBits8u,  uint8)
XGATHERBITS(p_gatherBits16u, uint16)
XGATHERBITS(p_gatherBits32u, uint32)
XGATHERBITS(p_gatherBits64u, uint64)

#undef	XGATHERBITS


#endif
