#ifndef _REDUCE_H
#define _REDUCE_H


#include "types.h"


#define	p_reduceAdd1u(datum) p_any(datum)

#define	XREDUCEADD(name, type, bitcnt, suffix) \
extern type \
name(register type datum);

XREDUCEADD(p_reduceAdd8,    int8,  8,  8)
XREDUCEADD(p_reduceAdd8u,  uint8,  8,  8u)
XREDUCEADD(p_reduceAdd16,   int16, 16, 16)
XREDUCEADD(p_reduceAdd16u, uint16, 16, 16u)
XREDUCEADD(p_reduceAdd32,   int32, 32, 32)
XREDUCEADD(p_reduceAdd32u, uint32, 32, 32u)
XREDUCEADD(p_reduceAdd64,   int64, 64, 64)
XREDUCEADD(p_reduceAdd64u, uint64, 64, 64u)
XREDUCEADD(p_reduceAddf,      f32, 32, f)
XREDUCEADD(p_reduceAddd,      f64, 64, d)

#undef	XREDUCEADD

#define	XREDUCEADDBITS(name, type, suffix) \
extern type \
name(register type datum, \
register int bits);

XREDUCEADDBITS(p_reduceAddBits8u,  uint8,  8u)
XREDUCEADDBITS(p_reduceAddBits16u, uint16, 16u)
XREDUCEADDBITS(p_reduceAddBits32u, uint32, 32u)
XREDUCEADDBITS(p_reduceAddBits64u, uint64, 64u)

#undef	XREDUCEADDBITS


#define	p_reduceMul1u(datum) p_all(datum)

#define	XREDUCEMUL(name, type, bitcnt, suffix) \
extern type \
name(register type datum);

XREDUCEMUL(p_reduceMul8,    int8,  8,  8)
XREDUCEMUL(p_reduceMul8u,  uint8,  8,  8u)
XREDUCEMUL(p_reduceMul16,   int16, 16, 16)
XREDUCEMUL(p_reduceMul16u, uint16, 16, 16u)
XREDUCEMUL(p_reduceMul32,   int32, 32, 32)
XREDUCEMUL(p_reduceMul32u, uint32, 32, 32u)
XREDUCEMUL(p_reduceMul64,   int64, 64, 64)
XREDUCEMUL(p_reduceMul64u, uint64, 64, 64u)
XREDUCEMUL(p_reduceMulf,      f32, 32, f)
XREDUCEMUL(p_reduceMuld,      f64, 64, d)

#undef	XREDUCEMUL

#define	XREDUCEMULBITS(name, type, suffix) \
extern type \
name(register type datum, \
register int bits);

XREDUCEMULBITS(p_reduceMulBits8u,  uint8,  8u)
XREDUCEMULBITS(p_reduceMulBits16u, uint16, 16u)
XREDUCEMULBITS(p_reduceMulBits32u, uint32, 32u)
XREDUCEMULBITS(p_reduceMulBits64u, uint64, 64u)

#undef	XREDUCEMULBITS


#define	p_reduceAnd1u(datum) p_all(datum)

#define	XREDUCEAND(name, type, bitcnt) \
extern type \
name(register type datum);

XREDUCEAND(p_reduceAnd8,    int8,  8)
XREDUCEAND(p_reduceAnd8u,  uint8,  8)
XREDUCEAND(p_reduceAnd16,   int16, 16)
XREDUCEAND(p_reduceAnd16u, uint16, 16)
XREDUCEAND(p_reduceAnd32,   int32, 32)
XREDUCEAND(p_reduceAnd32u, uint32, 32)
XREDUCEAND(p_reduceAnd64,   int64, 64)
XREDUCEAND(p_reduceAnd64u, uint64, 64)

#undef	XREDUCEAND

#define	XREDUCEANDBITS(name, type) \
extern type \
name(register type datum, \
register int bits);

XREDUCEANDBITS(p_reduceAndBits8u,  uint8)
XREDUCEANDBITS(p_reduceAndBits16u, uint16)
XREDUCEANDBITS(p_reduceAndBits32u, uint32)
XREDUCEANDBITS(p_reduceAndBits64u, uint64)

#undef	XREDUCEANDBITS


#define	p_reduceOr1u(datum) p_any(datum)

#define	XREDUCEOR(name, type, bitcnt) \
extern type \
name(register type datum);

XREDUCEOR(p_reduceOr8,    int8,  8)
XREDUCEOR(p_reduceOr8u,  uint8,  8)
XREDUCEOR(p_reduceOr16,   int16, 16)
XREDUCEOR(p_reduceOr16u, uint16, 16)
XREDUCEOR(p_reduceOr32,   int32, 32)
XREDUCEOR(p_reduceOr32u, uint32, 32)
XREDUCEOR(p_reduceOr64,   int64, 64)
XREDUCEOR(p_reduceOr64u, uint64, 64)

#undef	XREDUCEOR

#define	XREDUCEORBITS(name, type) \
extern type \
name(register type datum, \
register int bits);

XREDUCEORBITS(p_reduceOrBits8u,  uint8)
XREDUCEORBITS(p_reduceOrBits16u, uint16)
XREDUCEORBITS(p_reduceOrBits32u, uint32)
XREDUCEORBITS(p_reduceOrBits64u, uint64)

#undef	XREDUCEORBITS


#define	p_reduceMin1u(datum) p_all(datum)

#define	XREDUCEMIN(name, type, bitcnt, suffix) \
extern type \
name(register type datum);

XREDUCEMIN(p_reduceMin8,    int8,  8,  8)
XREDUCEMIN(p_reduceMin8u,  uint8,  8,  8u)
XREDUCEMIN(p_reduceMin16,   int16, 16, 16)
XREDUCEMIN(p_reduceMin16u, uint16, 16, 16u)
XREDUCEMIN(p_reduceMin32,   int32, 32, 32)
XREDUCEMIN(p_reduceMin32u, uint32, 32, 32u)
XREDUCEMIN(p_reduceMin64,   int64, 64, 64)
XREDUCEMIN(p_reduceMin64u, uint64, 64, 64u)
XREDUCEMIN(p_reduceMinf,      f32, 32, f)
XREDUCEMIN(p_reduceMind,      f64, 64, d)

#undef	XREDUCEMIN

#define	XREDUCEMINBITS(name, type) \
extern type \
name(register type datum, \
register int bits);

XREDUCEMINBITS(p_reduceMinBits8u,  uint8)
XREDUCEMINBITS(p_reduceMinBits16u, uint16)
XREDUCEMINBITS(p_reduceMinBits32u, uint32)
XREDUCEMINBITS(p_reduceMinBits64u, uint64)

#undef	XREDUCEMINBITS


#define	p_reduceMax1u(datum) p_any(datum)

#define	XREDUCEMAX(name, type, bitcnt, suffix) \
extern type \
name(register type datum);

XREDUCEMAX(p_reduceMax8,    int8,  8,  8)
XREDUCEMAX(p_reduceMax8u,  uint8,  8,  8u)
XREDUCEMAX(p_reduceMax16,   int16, 16, 16)
XREDUCEMAX(p_reduceMax16u, uint16, 16, 16u)
XREDUCEMAX(p_reduceMax32,   int32, 32, 32)
XREDUCEMAX(p_reduceMax32u, uint32, 32, 32u)
XREDUCEMAX(p_reduceMax64,   int64, 64, 64)
XREDUCEMAX(p_reduceMax64u, uint64, 64, 64u)
XREDUCEMAX(p_reduceMaxf,      f32, 32, f)
XREDUCEMAX(p_reduceMaxd,      f64, 64, d)

#undef	XREDUCEMAX

#define	XREDUCEMAXBITS(name, type) \
extern type \
name(register type datum, \
register int bits);

XREDUCEMAXBITS(p_reduceMaxBits8u,  uint8)
XREDUCEMAXBITS(p_reduceMaxBits16u, uint16)
XREDUCEMAXBITS(p_reduceMaxBits32u, uint32)
XREDUCEMAXBITS(p_reduceMaxBits64u, uint64)

#undef	XREDUCEMAXBITS


#endif
