#ifndef _SCAN_H
#define _SCAN_H


#include "types.h"


#define	XSCANADD(name, type, bitcnt, suffix) \
extern type \
name(register type datum);

XSCANADD(p_scanAdd1u,  uint1,  1,  1u)
XSCANADD(p_scanAdd8,    int8,  8,  8)
XSCANADD(p_scanAdd8u,  uint8,  8,  8u)
XSCANADD(p_scanAdd16,   int16, 16, 16)
XSCANADD(p_scanAdd16u, uint16, 16, 16u)
XSCANADD(p_scanAdd32,   int32, 32, 32)
XSCANADD(p_scanAdd32u, uint32, 32, 32u)
XSCANADD(p_scanAdd64,   int64, 64, 64)
XSCANADD(p_scanAdd64u, uint64, 64, 64u)
XSCANADD(p_scanAddf,      f32, 32, f)
XSCANADD(p_scanAddd,      f64, 64, d)

#undef	XSCANADD


#define	XSCANMUL(name, type, bitcnt, suffix) \
extern type \
name(register type datum);

XSCANMUL(p_scanMul1u,  uint1,  1,  1u)
XSCANMUL(p_scanMul8,    int8,  8,  8)
XSCANMUL(p_scanMul8u,  uint8,  8,  8u)
XSCANMUL(p_scanMul16,   int16, 16, 16)
XSCANMUL(p_scanMul16u, uint16, 16, 16u)
XSCANMUL(p_scanMul32,   int32, 32, 32)
XSCANMUL(p_scanMul32u, uint32, 32, 32u)
XSCANMUL(p_scanMul64,   int64, 64, 64)
XSCANMUL(p_scanMul64u, uint64, 64, 64u)
XSCANMUL(p_scanMulf,      f32, 32, f)
XSCANMUL(p_scanMuld,      f64, 64, d)

#undef	XSCANMUL


#define	XSCANAND(name, type, bitcnt) \
extern type \
name(register type datum);

XSCANAND(p_scanAnd1u,  uint1,  1)
XSCANAND(p_scanAnd8,    int8,  8)
XSCANAND(p_scanAnd8u,  uint8,  8)
XSCANAND(p_scanAnd16,   int16, 16)
XSCANAND(p_scanAnd16u, uint16, 16)
XSCANAND(p_scanAnd32,   int32, 32)
XSCANAND(p_scanAnd32u, uint32, 32)
XSCANAND(p_scanAnd64,   int64, 64)
XSCANAND(p_scanAnd64u, uint64, 64)

#undef	XSCANAND

#define	XSCANANDBITS(name, type) \
extern type \
name(register type datum, \
register int bits);

XSCANANDBITS(p_scanAndBits8u,  uint8)
XSCANANDBITS(p_scanAndBits16u, uint16)
XSCANANDBITS(p_scanAndBits32u, uint32)
XSCANANDBITS(p_scanAndBits64u, uint64)

#undef	XSCANANDBITS


#define	XSCANOR(name, type, bitcnt) \
extern type \
name(register type datum);

XSCANOR(p_scanOr1u,  uint1,  1)
XSCANOR(p_scanOr8,    int8,  8)
XSCANOR(p_scanOr8u,  uint8,  8)
XSCANOR(p_scanOr16,   int16, 16)
XSCANOR(p_scanOr16u, uint16, 16)
XSCANOR(p_scanOr32,   int32, 32)
XSCANOR(p_scanOr32u, uint32, 32)
XSCANOR(p_scanOr64,   int64, 64)
XSCANOR(p_scanOr64u, uint64, 64)

#undef	XSCANOR

#define	XSCANORBITS(name, type) \
extern type \
name(register type datum, \
register int bits);

XSCANORBITS(p_scanOrBits8u,  uint8)
XSCANORBITS(p_scanOrBits16u, uint16)
XSCANORBITS(p_scanOrBits32u, uint32)
XSCANORBITS(p_scanOrBits64u, uint64)

#undef	XSCANORBITS


#define	XSCANMIN(name, type, bitcnt, suffix) \
extern type \
name(register type datum);

XSCANMIN(p_scanMin1u,  uint1,  1,  1u)
XSCANMIN(p_scanMin8,    int8,  8,  8)
XSCANMIN(p_scanMin8u,  uint8,  8,  8u)
XSCANMIN(p_scanMin16,   int16, 16, 16)
XSCANMIN(p_scanMin16u, uint16, 16, 16u)
XSCANMIN(p_scanMin32,   int32, 32, 32)
XSCANMIN(p_scanMin32u, uint32, 32, 32u)
XSCANMIN(p_scanMin64,   int64, 64, 64)
XSCANMIN(p_scanMin64u, uint64, 64, 64u)
XSCANMIN(p_scanMinf,      f32, 32, f)
XSCANMIN(p_scanMind,      f64, 64, d)

#undef	XSCANMIN


#define	XSCANMAX(name, type, bitcnt, suffix) \
extern type \
name(register type datum);

XSCANMAX(p_scanMax1u,  uint1,  1,  1u)
XSCANMAX(p_scanMax8,    int8,  8,  8)
XSCANMAX(p_scanMax8u,  uint8,  8,  8u)
XSCANMAX(p_scanMax16,   int16, 16, 16)
XSCANMAX(p_scanMax16u, uint16, 16, 16u)
XSCANMAX(p_scanMax32,   int32, 32, 32)
XSCANMAX(p_scanMax32u, uint32, 32, 32u)
XSCANMAX(p_scanMax64,   int64, 64, 64)
XSCANMAX(p_scanMax64u, uint64, 64, 64u)
XSCANMAX(p_scanMaxf,      f32, 32, f)
XSCANMAX(p_scanMaxd,      f64, 64, d)

#undef	XSCANMAX


#define	XRANK(name, type, suffix) \
extern int \
name(register type datum);

XRANK(p_rank1u,  uint1,  1u)
XRANK(p_rank8,    int8,  8)
XRANK(p_rank8u,  uint8,  8u)
XRANK(p_rank16,   int16, 16)
XRANK(p_rank16u, uint16, 16u)
XRANK(p_rank32,   int32, 32)
XRANK(p_rank32u, uint32, 32u)
XRANK(p_rank64,   int64, 64)
XRANK(p_rank64u, uint64, 64u)
XRANK(p_rankf,      f32, f)
XRANK(p_rankd,      f64, d)

#undef	XRANK

#define	XRANKBITS(name, type, suffix) \
extern int \
name(register type datum, \
register int bits);

XRANKBITS(p_rankBits8u,  uint8,  8u)
XRANKBITS(p_rankBits16u, uint16, 16u)
XRANKBITS(p_rankBits32u, uint32, 32u)
XRANKBITS(p_rankBits64u, uint64, 64u)

#undef	XRANKBITS


extern int
p_population();

extern int
p_enumerate();


extern int
p_selectFirst();

extern int
p_selectOne();


#endif
