/*	timer.c

	Timer functions -- really unix process time calls in wrappers
	that collect time from all processors.

	1995 by Hank Dietz
*/


#include <sys/types.h>
#include <sys/times.h>
#ifndef	HZ
#define	HZ 100.0	/* 100Hz for Linux PCs, but BE CAREFUL!!!! */
#endif


#include "timer.h"


static struct tms dpu_start, dpu_stop;


void
p_timerStart()
{
	times(&dpu_start);
}


double
p_timerElapsed()
{
	times(&dpu_stop);

	return(((0.5 + dpu_stop.tms_utime + dpu_stop.tms_stime) -
		(dpu_start.tms_utime + dpu_start.tms_stime)) /
	       HZ);
}
