#ifndef _TYPES_H
#define _TYPES_H


/*	PAPERS-specific data types...
*/
typedef	unsigned char		barrier;


/*	PAPERS names for basic data types...
*/
typedef	int			uint1;
typedef	char			int8;
typedef	unsigned char		uint8;
typedef	short			int16;
typedef	unsigned short		uint16;
typedef	int			int32;
typedef	unsigned int		uint32;
typedef	long long		int64;
typedef	unsigned long long	uint64;
typedef	float			f32;
typedef	double			f64;


/*	Unions for PAPERS to access bits...
*/
#define	typeunion(type)	_##type
typedef	union { uint1   datum; uint1   bits; } _uint1;
typedef	union {  int8   datum; uint8   bits; } _int8;
typedef	union { uint8   datum; uint8   bits; } _uint8;
typedef	union {  int16  datum; uint16  bits; } _int16;
typedef	union { uint16  datum; uint16  bits; } _uint16;
typedef	union {  int32  datum; uint32  bits; } _int32;
typedef	union { uint32  datum; uint32  bits; } _uint32;
typedef	union {  int64  datum; uint64  bits; } _int64;
typedef	union { uint64  datum; uint64  bits; } _uint64;
typedef	union {    f32  datum; uint32  bits; } _f32;
typedef	union {    f64  datum; uint64  bits; } _f64;


#endif
