#ifndef _VOTE_H
#define _VOTE_H


#include "types.h"


#define	P_ABSTAIN -1	/* Specify this pe to abstain from a vote */


extern barrier
p_vote(register int pe);


extern int
p_voteCount(register int pe);


#define	XMATCH(name, type, bitcnt) \
extern barrier \
name(register type datum);

XMATCH(p_match1u,  uint1,  1)
XMATCH(p_match8,    int8,  8)
XMATCH(p_match8u,  uint8,  8)
XMATCH(p_match16,   int16, 16)
XMATCH(p_match16u, uint16, 16)
XMATCH(p_match32,   int32, 32)
XMATCH(p_match32u, uint32, 32)
XMATCH(p_match64,   int64, 64)
XMATCH(p_match64u, uint64, 64)

#undef	XMATCH


#define	XMATCHCOUNT(name, type, bitcnt) \
extern int \
name(register type datum);

XMATCHCOUNT(p_matchCount1u,  uint1,  1)
XMATCHCOUNT(p_matchCount8,    int8,  8)
XMATCHCOUNT(p_matchCount8u,  uint8,  8)
XMATCHCOUNT(p_matchCount16,   int16, 16)
XMATCHCOUNT(p_matchCount16u, uint16, 16)
XMATCHCOUNT(p_matchCount32,   int32, 32)
XMATCHCOUNT(p_matchCount32u, uint32, 32)
XMATCHCOUNT(p_matchCount64,   int64, 64)
XMATCHCOUNT(p_matchCount64u, uint64, 64)

#undef	XMATCHCOUNT


#define	XMATCHBITS(name, type) \
extern barrier \
name(register type datum, \
register int bits);

XMATCHBITS(p_matchBits8u,  uint8)
XMATCHBITS(p_matchBits16u, uint16)
XMATCHBITS(p_matchBits32u, uint32)
XMATCHBITS(p_matchBits64u, uint64)

#undef	XMATCHBITS


#define	XMATCHCOUNTBITS(name, type) \
extern int \
name(register type datum, \
register int bits);

XMATCHCOUNTBITS(p_matchCountBits8u,  uint8)
XMATCHCOUNTBITS(p_matchCountBits16u, uint16)
XMATCHCOUNTBITS(p_matchCountBits32u, uint32)
XMATCHCOUNTBITS(p_matchCountBits64u, uint64)

#undef	XMATCHCOUNTBITS


#endif
